function ImperatusInvasion:SceneTest()
end
function ImperatusInvasion:StartActivity()
    print("START! -- ImperatusInvasion:StartActivity()!");
    self.playertally = 0;
    self.playerlist = {};
    for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
        if self:PlayerActive(player) and self:PlayerHuman(player) then
        self.playerlist[player + 1] = true;
        self.playertally = self.playertally + 1;
            if not self:GetPlayerBrain(player) then
                local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
                if not foundBrain then
                    self.ActivityState = Activity.EDITING;
                    MovableMan:OpenAllDoors(true, Activity.NOTEAM);
                    AudioMan:ClearMusicQueue();
                    AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
                else
                    self:SetPlayerBrain(foundBrain, player);
                    self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
                    self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
                    self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
                end
            end
        end
    end

    self.factionA = "Imperatus.rte";
    self.factionAActorList = {"Scouting Robot", "All Purpose Robot", "Combat Robot"};
    self.factionACrabList = {};
    self.factionAPrimaryWeaponList = {"Mauler SG-23", "Bullpup AR-14", "Bulldog GG-49", "Marauder CN-05", "Banshee SR-02", "Devastator CN-72"};
    self.factionASecondaryWeaponList = {"Chunker SP-44", "Slugger GP-03"};

    self.LootList = {"Toilet Paper" , "Burger" , "Loco Cola" , "Nude Magazine" , "Teddy Bear" , "Expensive Liquor" , "Video Camera" , "Portable Game Computer" , "Platinum Lighter" , "Platinum Watch" , "Box of Cigars" , "Credit Card" , "Enemy Radio" , "Enemy Intel"};

    self.moduleList = {self.factionA};
    self.actorList = {self.factionAActorList};
    self.crabList = {self.factionACrabList};
    self.primaryWeaponList = {self.factionAPrimaryWeaponList};
    self.secondaryWeaponList = {self.factionASecondaryWeaponList};

    self.ESpawnTimer = Timer();
    
    if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
        self:SetTeamFunds(10000, Activity.TEAM_1);
        self:SetTeamFunds(10000, Activity.TEAM_2);
        self:SetTeamFunds(10000, Activity.TEAM_3);
        self:SetTeamFunds(10000, Activity.TEAM_4);
        self.BaseSpawnTime = 20000;
        self.RandomSpawnTime = 8000;
    elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
        self:SetTeamFunds(8000, Activity.TEAM_1);
        self:SetTeamFunds(8000, Activity.TEAM_2);
        self:SetTeamFunds(8000, Activity.TEAM_3);
        self:SetTeamFunds(8000, Activity.TEAM_4);
        self.BaseSpawnTime = 16000;
        self.RandomSpawnTime = 7000;
    elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
        self:SetTeamFunds(6000, Activity.TEAM_1);
        self:SetTeamFunds(6000, Activity.TEAM_2);
        self:SetTeamFunds(6000, Activity.TEAM_3);
        self:SetTeamFunds(6000, Activity.TEAM_4);
        self.BaseSpawnTime = 12000;
        self.RandomSpawnTime = 6000;
    elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
        self:SetTeamFunds(4000, Activity.TEAM_1);
        self:SetTeamFunds(4000, Activity.TEAM_2);
        self:SetTeamFunds(4000, Activity.TEAM_3);
        self:SetTeamFunds(4000, Activity.TEAM_4);
        self.BaseSpawnTime = 8000;
        self.RandomSpawnTime = 5000;
    elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
        self:SetTeamFunds(2000, Activity.TEAM_1);
        self:SetTeamFunds(2000, Activity.TEAM_2);
        self:SetTeamFunds(2000, Activity.TEAM_3);
        self:SetTeamFunds(2000, Activity.TEAM_4);
        self.BaseSpawnTime = 4000;
        self.RandomSpawnTime = 4500;
    elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
        self:SetTeamFunds(1000, Activity.TEAM_1);
        self:SetTeamFunds(1000, Activity.TEAM_2);
        self:SetTeamFunds(1000, Activity.TEAM_3);
        self:SetTeamFunds(1000, Activity.TEAM_4);
        self.BaseSpawnTime = 3500;
        self.RandomSpawnTime = 4000;
    end

    self.StartTimer = Timer();
    self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
end

function ImperatusInvasion:PauseActivity(pause)
        print("PAUSE! -- ImperatusInvasion:PauseActivity()!");
end

function ImperatusInvasion:EndActivity()
        print("END! -- ImperatusInvasion:EndActivity()!");
        
end

function ImperatusInvasion:UpdateActivity()

    if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then

	--Add a special item if they're CPU and near dead.
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			if MovableMan:IsActor(actor) and actor.Status ~= Actor.DYING then
				if actor.Health <= 1 then
					if math.random() <= 0.2 then
						if not actor:HasObject("Expensive Liquor") and not actor:HasObject("Portable Game Computer") and not actor:HasObject("Platinum Lighter") and not actor:HasObject("Platinum Watch") and not actor:HasObject("Video Camera") and not actor:HasObject("Box of Cigars") and not actor:HasObject("Enemy Radio") and not actor:HasObject("Enemy Intel") then
							actor:AddInventoryItem(CreateHeldDevice(self.LootList[math.random(#self.LootList)] , "UniTec.rte"));
						end
					end
				end
			end
		end
	end


        if not self.StartTimer:IsPastSimMS(1000) then
            MovableMan:OpenAllDoors(false, Activity.NOTEAM);
        end

        self:ClearObjectivePoints();
        local setTeam = { [Activity.TEAM_1] = false, [Activity.TEAM_2] = false, [Activity.TEAM_3] = false, [Activity.TEAM_4] = false };

        for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
            if self:PlayerActive(player) and self:PlayerHuman(player) then
                if not self.StartTimer:IsPastSimMS(3000) then
                    FrameMan:SetScreenText("Destroy the enemy brain(s)!", player, 333, 5000, true);
                end
                local team = self:GetTeamOfPlayer(player);
                if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
                    self:SetPlayerBrain(nil, player);
                    self:ResetMessageTimer(player);
                    FrameMan:ClearScreenText(player);
                    FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false);
                    if self.playerlist[player + 1] == true then
                        self.playerlist[player + 1] = false;
                        self.playertally = self.playertally - 1;
                    end
                else
                    if not setTeam[team] then
                        self:AddObjectivePoint("Protect!", self:GetPlayerBrain(player).AboveHUDPos, team, GameActivity.ARROWDOWN);
                        for otherPlayer = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
                            if otherPlayer ~= player and self:PlayerActive(otherPlayer) and self:PlayerHuman(otherPlayer) and MovableMan:IsActor(self:GetPlayerBrain(otherPlayer)) then
                                local otherTeam = self:GetTeamOfPlayer(otherPlayer);
                                if otherTeam ~= team then
                                    self:AddObjectivePoint("Destroy!", self:GetPlayerBrain(otherPlayer).AboveHUDPos, team, GameActivity.ARROWDOWN);
                                else
                                    self:AddObjectivePoint("Protect!", self:GetPlayerBrain(otherPlayer).AboveHUDPos, team, GameActivity.ARROWDOWN);
                                end
                            end
                        end
                        setTeam[team] = true;
                    end
                end
            end
        end

        if self.CPUTeam == nil then
            self.CPUTeam = Activity.NOTEAM;
            for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
                if self:PlayerActive(player) and not(self:PlayerHuman(player)) then
                    local team = self:GetTeamOfPlayer(player);
                    self.CPUTeam = team;
                end
            end
        end

        if self.CPUTeam ~= Activity.NOTEAM and self.ESpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 210 then
            local actor = {};
            for x = 0, math.random(2) do

                local factionPick = math.ceil(math.random()*#self.moduleList);
                if #self.crabList[factionPick] > 0 then
                    if math.random() > 0.01 then
                        actor[x] = CreateAHuman(self.actorList[factionPick][math.ceil(math.random()*#self.actorList[factionPick])],self.moduleList[factionPick]);
                        actor[x]:AddInventoryItem(CreateHDFirearm(self.primaryWeaponList[factionPick][math.ceil(math.random()*#self.primaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                        actor[x]:AddInventoryItem(CreateHDFirearm(self.secondaryWeaponList[factionPick][math.ceil(math.random()*#self.secondaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                        actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
                        actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
                        actor[x].Team = self.CPUTeam;
                    else
                        actor[x] = CreateACrab(self.crabList[factionPick][math.ceil(math.random()*#self.crabList[factionPick])],self.moduleList[factionPick]);
                        actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
                        actor[x].Team = self.CPUTeam;
                        break;
                    end
                else
                    actor[x] = CreateAHuman(self.actorList[factionPick][math.ceil(math.random()*#self.actorList[factionPick])],self.moduleList[factionPick]);
                    actor[x]:AddInventoryItem(CreateHDFirearm(self.primaryWeaponList[factionPick][math.ceil(math.random()*#self.primaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                    actor[x]:AddInventoryItem(CreateHDFirearm(self.secondaryWeaponList[factionPick][math.ceil(math.random()*#self.secondaryWeaponList[factionPick])]  ,self.moduleList[factionPick]));
                    actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
                    actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
                    actor[x].Team = self.CPUTeam;
                end
            end
            local ship = nil;
            local z = math.random();

		if z > 0.1 then
			if math.random() > 0.3 then
				ship = CreateACDropShip("Drop Ship MK1","Coalition.rte");
			else
				ship = CreateACRocket("Rocket MK1","Coalition.rte");
			end
		else
			ship = CreateACRocket("Rocket MK2","Coalition.rte");
		end

			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			ship.Team = self.CPUTeam;

			if self.playertally == 1 then
				for i = 1, #self.playerlist do
					if self.playerlist[i] == true then
						local sceneChunk = SceneMan.SceneWidth/3;
						local checkPos = self:GetPlayerBrain(i-1).Pos.X + (SceneMan.SceneWidth/2) + ( (sceneChunk/2) - (math.random()*sceneChunk) );
						if checkPos > SceneMan.SceneWidth then
							checkPos = checkPos - SceneMan.SceneWidth;
						elseif checkPos < 0 then
							checkPos = SceneMan.SceneWidth + checkPos;
						end
						ship.Pos = Vector(checkPos,-50);
						break;
					end
				end
			else
				ship.Pos = Vector(math.random()*SceneMan.SceneWidth,-50);
			end

			MovableMan:AddActor(ship);
			self.ESpawnTimer:Reset();
			self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.CPUTeam == Activity.NOTEAM then
			if self.playertally == 1 then
				for i = 1, #self.playerlist do
					if self.playerlist[i] == true then
						self.WinnerTeam = i - 1;
						ActivityMan:EndActivity();
					end
				end
			end
		else
			if self.playertally == 0 then
				self.WinnerTeam = self.CPUTeam;
				ActivityMan:EndActivity();
			end
		end
	else
        MovableMan:OpenAllDoors(true, Activity.NOTEAM);
		self.StartTimer:Reset();
	end
end